package be2;
import java.awt.*;
import java.awt.event.*;
//import java.swing.*;

import javax.swing.*;
import javax.swing.border.*;
import java.awt.BorderLayout;
import java.awt.Container;

class Fen_graph extends Frame{
//static final Dimension screensize = Toolkit.getDefaultToolkit().getScreenSize();
static final int largeurEcran=640;
static final int hauteurEcran=480+2;
int l=640;
int h=480;

public Fen_graph(){
	super();
	
	this.addWindowListener(new WindowAdapter(){
		public void windowClosing(WindowEvent e){
			System.exit(0);
		}});
}

public void paint(Graphics g){
	//association des couleurs aux proc -- couleur au pif
	for(int i=0;i<Simu.NbProcT;i++){
		Simu.liste[i].couleur = new Color(
			(int)Math.abs(Math.round(255.*Math.sin(Math.PI/2*(i+1)/Simu.NbProc()))),
			(int)Math.abs(Math.round(255.*Math.sin(Math.PI/3*(i+1)/Simu.NbProc()))),
			(int)Math.abs(Math.round(255.*Math.sin(Math.PI*(i+1)/Simu.NbProc()))));
	}
	for(int i=Simu.NbProcT;i<Simu.NbProc();i++){
		Simu.liste[i].couleur=new Color(
			(int)Math.abs(Math.round(255*Math.sin(Math.PI*(i+11.5)/Simu.NbProc()))),
			(int)Math.abs(Math.round(255*Math.sin(Math.PI/3*(i+11.5)/Simu.NbProc()))),
			(int)Math.abs(Math.round(255*Math.sin(Math.PI/4*(i+11.5)/Simu.NbProc()))));
	}
	for(int i=0;i<Simu.FTT.getTaille();i++){
		Simu.FTT.tampon[i].couleur=new Color(
			(int)Math.abs(Math.round(255*Math.cos(Math.PI/2*(i+5.5)/Simu.FTT.getTaille()))),
			(int)Math.abs(Math.round(255*Math.cos(Math.PI*(i+5.5)/Simu.FTT.getTaille()))),
			(int)Math.abs(Math.round(255*Math.cos(Math.PI/4*(i+5.5)/Simu.FTT.getTaille()))));
	}


	
	Graphics2D g2 = (Graphics2D)g;
	//char data[10]="bonjour";
	g2.drawString( "Traitement des taches en fonction du temps",60, 40 ) ;
	
	
	Simu.log.append("taille de FTT " + Simu.FTT.getTaille()+"\n");
	for(int j=0;j<Simu.FTT.getTaille();j++){
		Simu.log.append("tache " + Simu.FTT.tampon[j].numero_tache+"\n");
			Simu.log.append(Simu.FTT.tampon[j].taille+"\n");
			g2.setColor(Simu.FTT.tampon[j].couleur);
			g2.drawString( "Tache "+ Simu.FTT.tampon[j].numero_tache,10, 40 +20*(j+1)) ;
		for(int i=0;i<Simu.FTT.tampon[j].taille;i++){
			g2.setColor(Simu.liste[Simu.FTT.tampon[j].tab[i].nPro-1].couleur);
			g2.fillRect(60+Simu.FTT.tampon[j].tab[i].t_init*5,28 +20*(j+1),Simu.FTT.tampon[j].tab[i].duree*5,15) ;
			g2.setColor(new Color(110,110,110));
			for(int k=0;k<Simu.FTT.tampon[j].tab[i].duree;k++){
			g2.drawRect(60+Simu.FTT.tampon[j].tab[i].t_init*5+k*5,28 +20*(j+1),5,15) ;
			}
		}
	}
	int decalage_vertical=20+15+40+20*(Simu.FTT.getTaille());
	g2.setColor(new Color(0,0,0));
	g2.drawString( "Occupation des processeurs en fonction du temps",60,decalage_vertical ) ;
	
	g2.setColor(new Color(0,0,0));
	for(int i=0;i<1000;i++){
	//g2.drawLine(60+5*i,28 +20,60+5*i,28 +25*(Simu.FTT.getTaille()));
	}
	
	for(int j=0;j<Simu.NbProcT;j++){
			g2.setColor(Simu.liste[j].couleur);
			g2.drawString( "ProcT   "+ j,10, decalage_vertical +20*(j+1)) ;
	}
	for(int j=Simu.NbProcT;j<Simu.NbProc();j++){
			g2.setColor(Simu.liste[j].couleur);
			g2.drawString( "ProcES "+ j,10, decalage_vertical +20*(j+1)) ;
	}
	for(int j=0;j<Simu.FTT.getTaille();j++){
		for(int i=0;i<Simu.FTT.tampon[j].taille;i++){
			g2.setColor(Simu.FTT.tampon[j].couleur);
			g2.fillRect(60+Simu.FTT.tampon[j].tab[i].t_init*5,decalage_vertical-12 +20*(Simu.FTT.tampon[j].tab[i].nPro),Simu.FTT.tampon[j].tab[i].duree*5,15) ;
			g2.setColor(new Color(110,110,110));
			for(int k=0;k<Simu.FTT.tampon[j].tab[i].duree;k++){
			g2.drawRect(60+Simu.FTT.tampon[j].tab[i].t_init*5+5*k,decalage_vertical-12 +20*(Simu.FTT.tampon[j].tab[i].nPro),5,15) ;
			}
		}
	}
	g2.setColor(new Color(0,0,0));
	for(int i=0;i<1000;i++){
	//g2.drawLine(60+5*i,decalage_vertical,60+5*i,decalage_vertical-12 +25*(Simu.NbProcT+Simu.NbProcES));
	}
		
}

}