package be2;
import java.awt.Color;

public class Processeur extends Thread {
	int npro;
	int top;
	boolean isAlive = true;
	boolean type; // true pour traitement
	boolean travail = false;
	Color couleur;

public Processeur() {
	super();
}

public Processeur(int num, boolean type) {
	npro=num;
	this.type=type;	
}

public void mort() {
	isAlive=false;
}

public synchronized void run() {
	Tache T = new Tache();
	
	while (isAlive) {    
	  try {
		wait(); // attends top
		if (type) { // traitement
			if (travail)
				if (T.estFinie()) {
					Simu.log.append("dpt ds FTT : tache "+ T.numero_tache +" index " + T.index +" par ProcT "+npro+"\n");
					Simu.FTT.depose(T);
				}
				else {
					Simu.log.append("dpt ds FTB : tache "+ T.numero_tache +" index " + T.index +" par ProcT "+npro+"\n");
					Simu.FTB.depose(T);
				};

			if (Simu.FTD.estVide())
				if (!Simu.FTI.estVide()) {
					T=Simu.FTI.preleve();
					Simu.log.append("prise ds FTI : tache "+ T.numero_tache +" index " + T.index +" par ProcT "+npro+"\n");
					travail = true;
				}
				else {
					travail = false;
				}
			else {
				T=Simu.FTD.preleve();
				Simu.log.append("prise ds FTD : tache "+ T.numero_tache +" index " + T.index +" par ProcT "+npro+"\n");
				travail = true;
			};

			if (travail) {
				T.assignProc(npro, top);
				for (int i=0; i<T.getDuree()-1; i++) {
					Simu.log.append("attente "+ i +'/' +T.getDuree()+" tache "+ T.numero_tache +" index " + T.index +" par ProcT "+npro+"\n"); 
					wait();
					Simu.log.append("reception "+ i +'/' +T.getDuree()+" tache "+ T.numero_tache +" index " + T.index +" par ProcT "+npro+"\n");  
					yield();
				};
				T.nextSeq();
			};
		}
		else { // E/S
			if (travail) {
				Simu.FTD.depose(T);
				Simu.log.append("dpt ds FTD : tache "+ T.numero_tache +" index " + T.index +" par ProcES "+npro+"\n");
			};
			travail = false;
			if (!Simu.FTB.estVide()) {
				T=Simu.FTB.preleve();
				travail = true;
				Simu.log.append("prise ds FTB : tache "+ T.numero_tache +" index "+ T.index +"par ProcES "+npro+"\n");
				T.assignProc(npro, top);
				for (int i=0; i<T.getDuree()-1; i++) {
					Simu.log.append("attente "+ i +'/' +T.getDuree()+" tache "+ T.numero_tache +" index " + T.index +" par ProcES "+npro+"\n"); 
					wait();
					Simu.log.append("reception "+ i +'/' +T.getDuree()+" tache "+ T.numero_tache +" index " + T.index +" par ProcES "+npro+"\n");  
					yield();
				};
				T.nextSeq();
			};
		};
	  } catch (Exception e) { Simu.log.append("l'erreur est l: top = "+ top + " process = "+ npro);}

//	  System.out.println("reveil du processeur "+ npro);
//	  yield();
	}
	
	      
}

public synchronized void top(int num) {
	top = num; 
	Simu.log.append("top "+ top + " pour le processeur "+ npro+"\n");
	this.notify();
}
}