package be2;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.BorderLayout;
import java.awt.Container;

public class Simu {
	static int NbTaches, NbProcT, NbProcES;
	public static TamponCirc FTI, FTB, FTD, FTT;

	static Processeur liste[];
	static Horloge horloge;
	static Fen_graph frame;
	static JFrame fenetre;
	static JPanel panneau,le_panneau_graph1;
	static JTextArea log;
	static JScrollPane scrollPaneForLog;
	static Graphics graph1;

public Simu() {
	super();
}

public static void demarre(int T, int NPT, int NPES)  {
	NbTaches = T;
	NbProcT = NPT; NbProcES = NPES;
	
	
	fenetre = new JFrame("simulation");
	fenetre.addWindowListener(new WindowAdapter() {
				  public void windowClosing(WindowEvent e) {System.exit(0);}
	});
			 
	JButton start = new JButton("Demarrer la simulation");
	
	start.addActionListener(
            new ActionListener() {
                public void actionPerformed(ActionEvent e) {
					try {
					      	executer();
						  } catch (InterruptedException ee) {}
				}
			});
		
	panneau = new JPanel(new BorderLayout());
	log = new JTextArea(5, 30);
    log.setEditable(false);
   	scrollPaneForLog = new JScrollPane(log);
	
	panneau.add(scrollPaneForLog, BorderLayout.CENTER);	
	panneau.add(start,BorderLayout.WEST);
	fenetre.getContentPane().add(panneau);
	fenetre.pack();
 	fenetre.setVisible(true);
}


static void executer() throws InterruptedException {
	init();//initialise les files
	liste = new Processeur[NbProc()];
	for (int i=0; i<NbProcT; i++) 
		liste[i] = new Processeur((i+1),true);
	for (int i=0; i<NbProcES; i++) 
		liste[i+NbProcT] = new Processeur((i+1+NbProcT),false);
	horloge = new Horloge(liste);
	log.append("Initialisation des processeurs et des files termines\n");
	
	log.append("************ contenu de la file FTI  ********************\n");
	FTI.affiche();
	log.append("**********************************************************\n");
	
	
	for (int i=0; i<NbProc(); i++) 
		liste[i].start();
	horloge.start();
	
	horloge.join();// l'horloge attend la fin des autres threads
	
	log.append("on tue les threads\n");
/*	horloge.stop();
	for (int i=0; i<NbProc(); i++)
		liste[i].stop();*/
		
	log.append("************ contenu de la file FTT ********************\n");
	FTT.affiche();
	log.append("********************************************************\n");
	
	afficher_resultat();
}


public static void afficher_resultat(){
	frame = new Fen_graph();
	frame.setVisible(true);
	frame.setBounds(10,10,800,600);
	frame.setBackground(new Color(255,255,255));
}


public static void init() {
	FTI = new TamponCirc(100);
	FTI.remplit(NbTaches);
	FTB = new TamponCirc(100);
	FTD = new TamponCirc(100);
	FTT = new TamponCirc(100);
}

public static int NbProc() {
	return (NbProcT + NbProcES);
}
}